<template>
  <v-app style="height: 100vh !important; overflow: hidden;"
    :style="{ background: $vuetify.theme.themes.dark.background }">
    <v-container fluid>
      <v-row>
        <v-col cols="12" sm="3" class="border list-user">

          <!-- <v-app-bar flat color="rgba(0,0,0,0)">
            <v-btn tile color="white" x-large block>
              <v-icon left color="blue">
                fas fa-plus
              </v-icon>
              <v-divider class="mx-3" vertical></v-divider>
              New Conversation
            </v-btn>
          </v-app-bar> -->

          <v-app-bar flat color="rgba(0,0,0,0)">
            <v-toolbar-title class="title">
              Chat
            </v-toolbar-title>

            <v-spacer></v-spacer>
            <v-btn icon>
              <v-icon>fas fa-ellipsis-h</v-icon>
            </v-btn>
          </v-app-bar>
          <v-app-bar flat color="rgba(0,0,0,0)">

            <v-text-field v-model="search" filled label="Search Here" append-icon="mdi-magnify"
              color="grey"></v-text-field>
          </v-app-bar>

          <v-list two-line color="rgba(0,0,0,0)">
            <v-list-item-group v-model="selected" active-class="blue lighten-4" style="overflow: auto;">
              <template v-for="(item, index) in items">
                <v-list-item :key="item._id" v-show="item._id != me">
                  <v-badge bordered bottom color="green" dot offset-x="22" offset-y="26">
                    <v-list-item-avatar>
                      <v-img
                        src="https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcRLSmruqb2YwPK4qeIJE2FaMoOC86-IhLPCfS6wVQuw4PqYfrBky5ZufQSa7odKTgugNk0&usqp=CAU"></v-img>
                    </v-list-item-avatar>
                  </v-badge>
                  <template>
                    <v-list-item-content>
                      <v-list-item-title v-text="item.name"></v-list-item-title>
                    </v-list-item-content>
                  </template>
                </v-list-item>

                <v-divider v-if="index < items.length - 1" :key="index"></v-divider>
              </template>
            </v-list-item-group>
          </v-list>

        </v-col>
        <!-- massage -->
        <v-col cols="12" sm="6" class="border" style="position: relative;">
          <v-app-bar>
            <img src="https://cdn.vuetifyjs.com/images/lists/1.jpg"
              style="width: 52px; height: 52px; border-radius: 50%;" alt="">
            <div class="ml-4">{{ name }}</div>
          </v-app-bar>
          <div class="content">
            <div v-for="(item, index) in messages" :key="index" style="display: flex;"
              :class="{ 'flex-end': item.from == me }">
              <div v-if="(item.from == you)"
                style="background-color: #ccc; margin: 12px 0; padding: 6px 16px; border-radius: 18px; max-width: 60%; display: inline-block;">
                {{ item.message }}</div>
              <div v-else
                style="background-color: #ccc; margin: 12px 0; padding: 6px 16px; border-radius: 18px; max-width: 60%; display: inline-block;">
                {{ item.message }}</div>
            </div>
          </div>
          <v-app-bar color="rgba(0,0,0,0)" flat style="bottom: 0; position: absolute;">
            <v-text-field ref="chat" v-model="message" :append-outer-icon="message ? 'mdi-send' : 'mdi-send'" filled
              clear-icon="mdi-close-circle" clearable label="Enter message" type="text" @keyup.enter="sendMessage"
              @click:append-outer="sendMessage" @click:clear="clearMessage"></v-text-field>
          </v-app-bar>
        </v-col>
        <v-col cols="12" sm="3">
          <div style="text-align: right;">
            <span style="margin-right: 20px; font-size: 20px; font-weight: bold;">{{ myname }}</span>
            <button style="background-color: #4c71ee; padding: 10px; border-radius: 10px; color: #fff;"
              @click="logout">Đăng xuất</button>
          </div>
          <v-card class="text-center mt-8 mb-3" shaped>
            <v-badge bordered bottom color="green" dot offset-x="11" offset-y="13">
              <v-avatar class="mt-n7" size="60" elevation="10">
                <img src="https://cdn.vuetifyjs.com/images/lists/1.jpg" />
              </v-avatar>
            </v-badge>
            <v-card-title class="layout justify-center">{{ name }}</v-card-title>
            <v-list>
            </v-list>
          </v-card>
          <v-expansion-panels v-model="panel" multiple>
            <v-expansion-panel>
              <v-expansion-panel-header>
                <h3>Information</h3>
              </v-expansion-panel-header>
              <v-expansion-panel-content>

              </v-expansion-panel-content>
            </v-expansion-panel>
            <v-expansion-panel>
              <v-expansion-panel-header>
                <h3>Images(14)</h3>
              </v-expansion-panel-header>
              <v-expansion-panel-content>

              </v-expansion-panel-content>
            </v-expansion-panel>
            <v-expansion-panel>
              <v-expansion-panel-header>
                <h3>Files(3) </h3>
              </v-expansion-panel-header>
              <v-expansion-panel-content>
                <v-list shaped>
                  <v-list-item-group>
                    <v-list-item v-for="(item, i) in files" :key="i">
                      <v-list-item-icon>
                        <v-icon v-text="item.icon" color="green"></v-icon>
                      </v-list-item-icon>
                      <v-list-item-content>
                        <v-list-item-title v-text="item.text"></v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                  </v-list-item-group>
                </v-list>
              </v-expansion-panel-content>
            </v-expansion-panel>
            <v-expansion-panel>
              <v-expansion-panel-header>
                <h3>Pinned items</h3>
              </v-expansion-panel-header>
              <v-expansion-panel-content>

              </v-expansion-panel-content>
            </v-expansion-panel>


          </v-expansion-panels>

        </v-col>
      </v-row>
    </v-container>
  </v-app>
</template>
<script>
import { httpClient } from "../_utils/httpClient"
import { io } from 'socket.io-client';

export default {
  data: () => ({
    entries: {},
    selected: 4,
    search: '',
    items: [],
    files: [
      { text: 'Landing_page.zip', icon: ' mdi-cloud-upload' },
      { text: 'Requirements.pdf', icon: ' mdi-cloud-upload' },
      { text: 'Uwagi.docx', icon: ' mdi-cloud-upload' },
    ],
    panel: [2],
    password: 'Password',
    show: false,
    message: '',
    me: '',
    you: '',
    marker: true,
    iconIndex: 0,
    messages: [
    ],
    name: '',
    myname: '',
  }),
  watch: {
    async selected() {
      this.name = this.items[this.selected].name
      let id1 = this.items[this.selected]._id
      let id2 = localStorage.getItem('id')
      console.log(id1, id2, "checck id 1");
      let response = await httpClient.get('room', {
        params: {
          id1: id1,
          id2: id2
        }
      })
      if (response.data.code == 0) {
        if (!response.data.data) {
          let id1 = this.items[this.selected]._id
          let id2 = localStorage.getItem('id')
          let entry = {
            id1: id1,
            id2: id2,
            messages: [],
            id1Name: localStorage.getItem('name'),
            id2Name: this.items[this.selected].name
          }
          let create = await httpClient.post('room/create', { ...entry })
          console.log(create);
          let response = await httpClient.get('room', {
            params: {
              id1: id1,
              id2: id2
            }
          })
          this.entries = response.data.data
          this.messages = response.data.data.messages
          this.you = response.data.data.id1 == this.me ? response.data.data.id2 : response.data.data.id1
          let objDiv = document.querySelector(".content");
          objDiv.scrollTop = objDiv.scrollHeight;
          return;
        }
        this.entries = response.data.data
        this.messages = response.data.data.messages
        this.you = response.data.data.id1 == this.me ? response.data.data.id2 : response.data.data.id1
        setTimeout(() => {
          let objDiv = document.querySelector(".content");
          objDiv.scrollTop = objDiv.scrollHeight;
        }, 0);
      }
    },
    search() {
      console.log("search", this.search)
    }
  },
  computed: {
    theme() {
      return this.$vuetify.theme.dark ? "dark" : "light";
    },

  },
  methods: {
    logout() {
      localStorage.clear()
      this.$router.push({ name: 'login' })
    },
    async sendMessage() {
      if (!this.message.trim()) {
        this.clearMessage()
        return false;
      }
      let entry = {
        from: this.me,
        to: this.you,
        message: this.message
      }
      console.log(entry, "messs");
      this.socket.emit('send', entry)
      this.entries.messages.push({
        from: this.me,
        to: this.you,
        message: this.message
      })
      let response = await httpClient.post('room/update', this.entries)
      console.log(response);
      let objDiv = document.querySelector(".content");
      objDiv.scrollTop = objDiv.scrollHeight;
      this.clearMessage()
    },
    clearMessage() {
      this.message = ''
      this.$refs.chat.focus()
    },
    resetIcon() {
      this.iconIndex = 0
    },
  },
  async created() {
    this.myname = localStorage.getItem('name');
    this.me = localStorage.getItem('id')
    let response = await httpClient.get('user/find');
    this.items = response.data.data
    this.socket = io(process.env.VUE_APP_HOST_DEVELOPMENT);
    this.selected = 0
    setTimeout(() => {
      let objDiv = document.querySelector(".content");
      objDiv.scrollTop = objDiv.scrollHeight;
    }, 0);
    this.socket.on('receive', (data) => {
      console.log(data, this.me, "cehck");
      if (data.to == this.me) {
        this.messages.push(data);
        setTimeout(() => {
          let objDiv = document.querySelector(".content");
          objDiv.scrollTop = objDiv.scrollHeight;
        }, 0);
      }
    })
  }
};
</script>
<style scoped>
.border {
  border-right: 1px solid grey;
}

.list-user {
  overflow: auto;
  height: 100vh;
}

.flex-end {
  justify-content: flex-end;
}

.content {
  padding: 0 12px;
  margin-top: 12px;
  overflow: auto;
  height: 75vh;
  background-color: rgb(78, 82, 101);
  border-radius: 4px;
}

::-webkit-scrollbar {
  width: 4px;
}

/* Track */
::-webkit-scrollbar-track {
  background: #4e5265;
}

/* Handle */
::-webkit-scrollbar-thumb {
  background: #888;
}

/* Handle on hover */
::-webkit-scrollbar-thumb:hover {
  background: #555;
}
</style>
